unit Unit1;

//https://wiki.lazarus.freepascal.org/TTaskDialog
//https://stackoverflow.com/questions/4979556/how-to-use-the-ttaskdialog
{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    TaskDialog2: TTaskDialog;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure TaskDialog2ButtonClicked(Sender: TObject;
      AModalResult: TModalResult; var ACanClose: Boolean);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
 TaskDialog2.Execute;
 ShowMessage(Format('You chose %d.', [TaskDialog2.RadioButton.Index]));
end;


procedure TForm1.TaskDialog2ButtonClicked(Sender: TObject;
  AModalResult: TModalResult; var ACanClose: Boolean);
begin
 if AModalResult = mrOk     then ShowMessage('Okay');
 if AModalResult = mrCancel then ShowMessage('Cancel');
end;


procedure TForm1.Button2Click(Sender: TObject);
var TaskDialog1: TTaskDialog;
begin
 TaskDialog1   := TTaskDialog.Create(self);
 try
  TaskDialog1.Caption      := 'Install';
  TaskDialog1.Title        := 'My Package';
  TaskDialog1.Text         := 'Do you want to install the package?';
  TaskDialog1.MainIcon     := tdiQuestion;

  TaskDialog1.RadioButtons.Add;
  TaskDialog1.RadioButtons.Items[0].Caption:='Yes, please';

  TaskDialog1.RadioButtons.Add;
  TaskDialog1.RadioButtons.Items[1].Caption:='No, thank you';


  //From here it is executed when a button is pressed
   if TaskDialog1.Execute then
    begin
     if TaskDialog1.ModalResult = mrOk     then ShowMessage('Okay');
     if TaskDialog1.ModalResult = mrCancel then ShowMessage('Cancel');

     ShowMessage(Format('You chose %d.', [TaskDialog1.RadioButton.Index]));
    end;

 finally
  TaskDialog1.Free;
 end;
end;
end.

